<template>
	<view class="container">
		<!-- 顶部logo and 搜索 start-->
		<view class="index-top-wrap">
			<image src="../../static/index/index-top.png" mode="widthFix" class="index-top"></image>
			<view class="status_bar fud"></view>
			<view class="top-search flex fud">
				<view class="search-box flex" @click="clickSearch()">
					<image class="search" src="../../static/icon/search-h.png" mode=""></image>
					<view class="search-font">输入关键词搜索</view>
				</view>
			</view>
			<!-- 顶部logo and 搜索 end-->
			<!-- <view class="jg fud" style="background-color: #fff;"></view> -->
			<!-- 轮播图 start -->
			<swiper class="top-swiper fud" autoplay="true" duration="400" interval="5000" @change="swiperChange">
				<swiper-item v-for="(item, index) in carouselList" :key="index" class="carousel-item"
					@click="bannerNavToUrl(item)">
					<image :src="item.pic" />
				</swiper-item>
			</swiper>
			<!-- 轮播图 end -->
		</view>
		<!-- 顶部logo and 搜索 end-->
		<view class="jg" style="background-color: #fff;"></view>
		<!-- <view class="swiper-btm flex">
			<view class="btm-item flex">
				<image src="../../static/icon/index-gou.png" mode=""></image>
				<view class="">自用购物返利</view>
			</view>
			<view class="btm-item flex">
				<image src="../../static/icon/index-gou.png" mode=""></image>
				<view class="">分享好友赚钱</view>
			</view>
			<view class="btm-item flex">
				<image src="../../static/icon/index-gou.png" mode=""></image>
				<view class="">超值正品优惠</view>
			</view>
		</view> -->
		<!-- 分类 start -->
		<view class="cate-section flex">
			<view class="cate-item flex" @click="navto('/pages/category/category')" >
				<view class="img-wrapper flex">
					<image src="../../static/icon/in1.png" mode=""></image>
				</view>
				<view class="item-title">全部商品</view>
			</view>
			<view class="cate-item flex" @click="navto('/pages/user/team')">
				<view class="img-wrapper flex">
					<image src="../../static/icon/in2.png" mode=""></image>
				</view>
				<view class="item-title">我的团队</view>
			</view>
			<view class="cate-item flex" @click="openKf">
				<view class="img-wrapper flex">
					<image src="../../static/icon/in3.png" mode=""></image>
				</view>
				<view class="item-title">联系客服</view>
			</view>
			<view class="cate-item flex" @click="navto('/pages/user/shareQrCode',1)">
				<view class="img-wrapper flex">
					<image src="../../static/icon/in4.png" mode=""></image>
				</view>
				<view class="item-title">邀请好友</view>
			</view>
		</view>
		<!-- 分类 ed -->

		<!-- 商品列表 start -->
		<view class="product-box" v-if="navList.bd.list.length > 0">
			<view class="product-tit flex">
				<view class="hx"></view>
				<view class="tit">爆单专区</view>
				<view class="hx"></view>
			</view>
			<view class="hotgoods">
				<view class="hotgoods-item" v-for="bditem in navList.bd.list" :key="bditem.id"
					@click="navto('/pages/product/product?id=' + bditem.id + '&isbd=1')" style="height: 520rpx;">
					<view class="image-wrapper">
						<image class="image" :src="bditem.image" mode="scaleToFill"></image>
					</view>
					<view class="flex" style="flex-direction: column;justify-content: space-between;align-items: flex-start;height: 170rpx;">
						<view class="title clamp2">{{bditem.store_name}}</view>
						<view class="hot-price">
							<view class="price">
								<text class="font-size-sm"></text>
								<text>￥{{ bditem.price * 1 }}</text>
								<text class="give-jf">赠{{bditem.give_integral*1}}积分</text>
							</view>
							
						</view>
					</view>

				</view>
			</view>
		</view>
		<!-- 商品列表 ed-->
		<view class="jg" style="background-color: #f5f5f5;height: 20rpx;" v-if="navList.jf.list.length > 0">
			
		</view>
		<!-- 商品列表 start -->
		<view class="product-box" v-if="navList.jf.list.length > 0">
			<view class="product-tit flex">
				<view class="hx"></view>
				<view class="tit">积分兑换</view>
				<view class="hx"></view>
			</view>
			<view class="hotgoods">
				<view class="hotgoods-item" v-for="jfitem in navList.jf.list" :key="jfitem.id"
					@click="navto('/pages/product/product?id=' + jfitem.id + '&isjf=1')" style="height: 520rpx;">
					<view class="image-wrapper">
						<image class="image" :src="jfitem.image" mode="scaleToFill"></image>
					</view>
					<view class="flex" style="flex-direction: column;justify-content: space-between;align-items: flex-start;height: 170rpx;">
						<view class="title clamp2">{{jfitem.store_name}}</view>
						<view class="hot-price">
							<view class="price">
								<text class="font-size-sm"></text>
								<text>￥{{ jfitem.price * 1 }}</text>
								<!-- <text class="give-jf">赠2000积分</text> -->
								<text class="ot-pirce" v-if="jfitem.ot_price*1 > jfitem.price*1">￥{{ jfitem.ot_price*1 }}</text>
							</view>
						</view>
					</view>
		
				</view>
			</view>
		</view>
		<!-- 商品列表 ed-->
		
		<uni-popup ref="popupkf" type="center">
			<view class="popup-box">
				<view class="img">
					<image src="../../static/img/img009.png" mode=""></image>
				</view>
				<view class="mian">
					<view class="delivery">
						<view class="title">已经为您定制专属客服</view>
						<image src="../../static/img/img010.png" mode=""></image>
					</view>
					<view class="nocancel">客服VX:{{ text }}</view>
					<view class="comfirm-box">
						<view class="cancel" @click="cancel">取消</view>
						<view class="comfirm" @click="comfirm(text)">复制微信</view>
					</view>
				</view>
			</view>
		</uni-popup>
	</view>
</template>

<script>
	import {
		loadIndexs,
		groom1
	} from '@/api/index.js';
	import {
		getUserInfo,
		spread
	} from '@/api/user.js';
	import {
		getBargainList,
		getProducts,
		goodsDetail,
		poster
	} from '@/api/product.js';
	import {
		saveUrl,
		interceptor
	} from '@/utils/loginUtils';
	import {
		mapState,
		mapMutations
	} from 'vuex';
	// #ifdef H5
	import {
		weixindata,
		shareLoad
	} from '@/utils/wxAuthorized';
	// #endif
	export default {
		data() {
			return {
				text: '', //客服微信
				page: 1,
				limitt: 20,
				loadingType: 'more',
				current: 0,
				shareShow: false, //分享海报
				pageProportion: 0, //保存页面基于750宽度的比例
				swiperHeight: 0,
				checkid: 0,
				titleNViewBackground: '',
				swiperCurrent: 0,
				swiperLength: 0,
				carouselList: [], //轮播列表
				page: 1,
				limit: 5,
				firstList: [],
				goodList: [], //商品列表
				shopList: [],
				shareImage: '',
				navList:{
					bd: {
						page: 1,
						limit: 10,
						loaded: false,
						loadingType: 'more',
						list: [],
						status: 1
					},
					jf: {
						page: 1,
						limit: 10,
						loaded: false,
						loadingType: 'more',
						list: [],
						status: 3
					}
				}
			};
		},
		computed: {
			...mapState('user', ['hasLogin', 'userInfo'])
		},
		onReachBottom() {

		},
		onLoad: function(option) {
			// #ifdef MP
			if (option.scene) {
				// 存储小程序邀请人
				uni.setStorage({
					key: 'spread_code',
					data: option.scene
				});
			}
			// #endif
		},
		onShow: function() {
			this.getGoodList()
			this.getGoodList(2)
			this.loadData();
			this.groom1()
		},
		methods: {
			//获取复购商品
			groom1() {
				groom1().then(res => {
					console.log(res)
					this.fgList = res.data.list
				})
			},
			getGoodList(type=1) {
				let that = this;
				let item ;
				if(type == 1) {
					item = that.navList.bd
				}else {
					item = that.navList.jf
				}
				if(item.loadingType == 'loading' || item.loadingType == 'nomore') {
					return 
				}
				item.loadingType = 'loading'
				getProducts({
					cid: item.status,
					page: item.page,
					limit: item.limit
				}).then(res => {
					item.list = item.list.concat(res.data)
					// if(item.limit == res.data) {
					// 	item.loadingType = 'more'
					// }else {
					// 	item.loadingType = 'nomore'
					// }
				})
			},
			navto(url, type = 0) {
				if (type == 1) {
					if (!this.hasLogin) {
						// 保存地址
						saveUrl();
						// 登录拦截
						interceptor();
					} else {
						uni.navigateTo({
							url,
							fail() {
								uni.switchTab({
									url
								})
							}
						})
					}
				} else {
					uni.navigateTo({
						url,
						fail() {
							uni.switchTab({
								url
							})
						}
					})
				}

			},
			navTo(url) {
				if (url == '') {
					this.$api.msg('暂未开通，敬请期待');
				} else {
					this.navto(url)
				}
			},
			// 點擊搜索框
			clickSearch() {
				uni.navigateTo({
					url: '/pages/product/search'
				});
			},
			// 监听图片加载完成
			onImageError(key, index) {
				this[key][index].image = '/static/error/errorImage.jpg';
			},
			// 请求载入数据
			async loadData() {
				loadIndexs({})
					.then(({
						data
					}) => {
						let goods = data.info;
						console.log(goods, '商品信息');
						this.carouselList = data.banner;
						this.swiperLength = this.carouselList.length;
						this.bastList = data.giftInfo; //会员礼包
						data.info.firstList.forEach(e => {
							e.isVip = e.store_type ? "3" : "0"
						})
						this.firstList = data.info.firstList //首页商品
						uni.stopPullDownRefresh();
					})
					.catch(e => {
						uni.stopPullDownRefresh();
					});
			},
			//轮播图切换修改背景色
			swiperChange(e) {
				const index = e.detail.current;
				this.swiperCurrent = index;
				this.titleNViewBackground = this.carouselList[index].background;
			},
			// 轮播图跳转
			bannerNavToUrl(item) {
				// #ifdef H5
				console.log(item.wap_url.indexOf('http'), 'banner');
				if (item.wap_url.indexOf('http') >= 0) {
					window.location.href = item.wap_url;
				}
				// #endif
				//测试数据没有写id，用title代替
				uni.navigateTo({
					url: item.wap_url
				});
			},
			comfirm(text) {
				console.log(text);
				const result = this.uniCopy(text);
				if (result === false) {
					uni.showToast({
						title: '不支持'
					});
				} else {
					uni.showToast({
						title: '复制成功',
						icon: 'none'
					});
				}
				this.$refs.popupkf.close();
			},
			uniCopy(content) {
				/**
				 * 小程序端 和 app端的复制逻辑
				 */
				//#ifndef H5
				uni.setClipboardData({
					data: content,
					success: function() {
						console.log('success');
						return true;
					}
				});
				//#endif

				/**
				 * H5端的复制逻辑
				 */
				// #ifdef H5
				if (!document.queryCommandSupported('copy')) {
					//为了兼容有些浏览器 queryCommandSupported 的判断
					// 不支持
					return false;
				}
				let textarea = document.createElement('textarea');
				textarea.value = content;
				textarea.readOnly = 'readOnly';
				document.body.appendChild(textarea);
				textarea.select(); // 选择对象
				textarea.setSelectionRange(0, content.length); //核心
				let result = document.execCommand('copy'); // 执行浏览器复制命令
				textarea.remove();
				return result;
				// #endif
			},
			// 打开客服
			openKf() {
				this.$refs.popupkf.open();
			},
			// 关闭客服
			cancel() {
				this.$refs.popupkf.close();
			},
		}
	};
</script>

<style lang="scss">
	page {
		background: #ffff;
		min-height: 100%;
		height: auto;
	}

	// 顶部搜索
	.top-search {
		height: 80rpx;
		padding: 0 20rpx;
		margin-bottom: 20rpx;
		// background-color: #fff;
	
		.top-logo {
			width: 50rpx;
			// height: 50rpx;
			margin-right: 10rpx;
	
			image {
				width: 48rpx;
			}
	
		}
	
		.search-box {
			justify-content: center;
			width: 698rpx;
			height: 60rpx;
			background: #EEEEEE;
			// box-shadow: 0px 10rpx 20rpx 0px rgba(4, 114, 69, 0.22);
			border-radius: 30rpx;
	
			.search {
				width: 34rpx;
				height: 34rpx;
			}
	
			.search-font {
				margin-left: 14rpx;
				font-size: 28rpx;
				font-family: PingFang SC;
				font-weight: 500;
				color: #CBCBCB;
			}
		}
	}
	
	// 顶部轮播图
	.top-swiper {
		width: 690rpx;
		height: 365rpx;
	
		// margin: 20rpx 0 0;
		border-radius: 20rpx;
		margin: auto;
		image {
			width: 690rpx;
			height: 365rpx;
			border-radius: 20rpx;
		}
	}
	.swiper-btm {
		height: 60rpx;
		width: 750rpx;
		background-color: #fff;
		margin-bottom: 20rpx;
		font-size: 26rpx;
		font-weight: 500;
		color: #333333;

		.btm-item {
			flex-grow: 1;
			justify-content: center;

			image {
				width: 25rpx;
				height: 25rpx;
				margin-right: 14rpx;
			}
		}
	}

	.jg {
		height: 20rpx;
		background: #F8F8F8;
	}

	// 分类
	.cate-section {
		justify-content: space-around;
		background-color: #fff;
		padding: 0rpx 0 30rpx;

		.cate-item {
			flex-grow: 0;
			width: 20%;
			flex-direction: column;
			text-align: center;
			align-items: center;
			justify-content: center;

			.img-wrapper {
				width: 100rpx;
				height: 100rpx;
				border-radius: 20rpx;
				position: relative;

				image {
					width: 100rpx;
					height: 100rpx;
					position: absolute;
					left: 50%;
					top: 50%;
					transform: translate(-50%, -50%);
				}
			}

			.item-title {
				margin-top: 15rpx;
				font-size: 24rpx;
				font-weight: 500;
				color: #3F3F3F;
			}
		}
	}

	.product-box {
		margin-top: 20rpx;
		background: #ffffff;
		padding: 26rpx 0 20rpx;

		.product-tit {
			justify-content: center;

			image {
				width: 609rpx;
				height: 31rpx;
			}
			.hx {
				width: 120rpx;
				height: 1rpx;
				background: #363636;
				color: #363636;
				line-height: 28px;
			}
					
			.tit {
				margin: 0 70rpx;
				font-size: 32rpx;
				font-weight: 500;
				color: #363636;
			}
		}

		.in-ban {
			margin-top: 40rpx;
			width: 750rpx;
			height: 220rpx;
		}
	}

	.hotgoods {
		margin-top: 38rpx;
		width: 100%;
		display: flex;
		flex-wrap: wrap;
		padding: 0 20rpx 30rpx;
		justify-content: space-between;

		.hotgoods-item {
			width: 345rpx;
			background-color: #ffffff;
			border-radius: 12rpx;
			box-shadow: 0 0 15rpx rgba(0, 0, 0, 0.2);
			margin-bottom: 15rpx;

			.image-wrapper {
				width: 345rpx;
				height: 345rpx;
				border-radius: 3px;
				overflow: hidden;
				position: relative;

				.image-bg {
					position: absolute;
					top: 0;
					left: 0;
					right: 0;
					bottom: 0;
					width: 100%;
					height: 100%;
					opacity: 1;
					border-radius: 12rpx 12rpx 0 0;
					z-index: 2;
				}

				.image {
					width: 100%;
					height: 100%;
					opacity: 1;
					border-radius: 12rpx 12rpx 0 0;
				}
			}

			.title {
				margin-top: 24rpx;
				padding: 0 20rpx;
				font-size: 32rpx;
				font-weight: 500;
				color: #333333;
			}

			.hot-price {
				display: flex;
				justify-content: flex-start;
				align-items: center;
				// padding: 14rpx 0 30rpx;

				.hotPrice-box {
					padding: 2rpx 6rpx;

					background: linear-gradient(90deg, #c79a4c, #f9df7f);
					border-radius: 5rpx;
					text-align: center;
					line-height: 28rpx;
					font-size: 20rpx;
					font-family: Source Han Sans CN;
					font-weight: 400;
					color: #ffffff;
				}

				.price {
					margin-left: 10rpx;
					font-size: 36rpx;
					color: #ff0000;
					font-weight: 500;
					display: flex;
					justify-content: flex-start;
					align-items: center;
					.jf {
						font-size: 20rpx;
					}
					.give-jf {
						display: inline-block;
						padding: 8rpx;
						
						background: linear-gradient(90deg, #FF834D, #FF2600);
						border-radius: 12rpx 0px 12rpx 0px;
						
						font-size: 22rpx;
						font-weight: 500;
						color: #FFFFFF;
						margin-left: 22rpx;
					}
					.ot-pirce {
						margin-left: 7rpx;
						font-size: 26rpx;
						font-weight: 500;
						text-decoration: line-through;
						color: #999999;
						align-self: flex-end;
					}
					
				}

				.yuanPrice {
					margin-left: 10rpx;
					font-size: 20rpx;
					font-family: PingFang SC;
					font-weight: 500;
					text-decoration: line-through;
					color: #999999;
				}

				.cart-icon {
					image {
						width: 44rpx;
						height: 44rpx;
					}
				}
			}
		}
	}

	.popup-box {
		width: 522rpx;
		height: 605rpx;
		background-color: #ffffff;
		border-radius: 20rpx;
		position: relative;

		.img {
			position: relative;
			top: -56rpx;
			left: 0;
			width: 522rpx;
			height: 132rpx;
			display: flex;
			justify-content: center;

			image {
				border-radius: 20rpx 20rpx 0 0;
				width: 450rpx;
				height: 132rpx;
			}
		}

		.mian {
			margin-top: -44rpx;
			display: flex;
			flex-direction: column;
			align-items: center;
			// padding: 32rpx 32rpx;
			background-color: #ffffff;
			border-radius: 0 0 20rpx 20rpx;
			text-align: center;

			.delivery {
				font-size: 40rpx;
				color: #333333;
				display: flex;
				align-items: center;
				flex-direction: column;

				image {
					margin-top: 48rpx;
					width: 172rpx;
					height: 160rpx;
				}
			}

			.nocancel {
				font-size: 32rpx;
				color: #333333;
				margin-top: 14rpx;
			}

			.comfirm-box {
				margin-top: 52rpx;
				display: flex;
				// margin-bottom: 32rpx;

				// justify-content: space-around;
				.cancel {
					display: flex;
					align-items: center;
					justify-content: center;
					width: 197rpx;
					height: 74rpx;
					border: 1px solid #dcc786;
					border-radius: 38rpx;

					font-size: 32rpx;
					color: #605128;
				}

				.comfirm {
					margin-left: 32rpx;
					display: flex;
					align-items: center;
					justify-content: center;
					width: 197rpx;
					height: 74rpx;
					background: linear-gradient(-90deg, #d1ba77 0%, #f7e8ad 100%);
					border-radius: 38px;
					font-size: 32rpx;
					color: #605128;
				}
			}
		}
	}
	.index-top-wrap {
		position: relative;
		.index-top {
			width: 750rpx;
			position: absolute;
		}
		.fud {
			position: relative;
		}
	}
</style>
